package com.sencorsta.rabs.obj.ai.scene.challenge;

import cn.hutool.core.thread.ThreadUtil;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sencorsta.rabs.annotation.SceneAnnotation;
import com.sencorsta.rabs.obj.ai.AiManage;
import com.sencorsta.rabs.obj.ai.api.BaseScene;
import com.sencorsta.rabs.obj.ai.api.Scene;
import org.opencv.core.Point;

import java.awt.AWTException;

/**
 * 挑战界面
 */
@SceneAnnotation("SceneMain")
public class SceneMain_Challenge extends BaseScene implements Scene {
    @JsonIgnore
    @Override
    public float getPriority() {
        return 4.0f;
    }

    private static String PathEnter = System.getProperty("user.dir") + "\\opencv\\scene\\challenge\\enter.png";
    private static String PathCheck = System.getProperty("user.dir") + "\\opencv\\scene\\challenge\\check.png";
    private static String PathBack = System.getProperty("user.dir") + "\\opencv\\scene\\challenge\\back.png";

    private static String PathRightdoor = System.getProperty("user.dir") + "\\opencv\\scene\\challenge\\rightDoor.png";
    private static String PathGoLeft = System.getProperty("user.dir") + "\\opencv\\scene\\challenge\\goLeft.png";
    private static String PathGoRight = System.getProperty("user.dir") + "\\opencv\\scene\\challenge\\goRight.png";

    @Override
    public void back() throws AWTException {
        moveToClick(PathBack, AiManage.getInstance().getCheckPoint());
    }

    @Override
    public void open() throws AWTException {
        while (AiManage.getInstance().isRunning() && !check()) {
            AiManage.getInstance().updateWindow();
            ThreadUtil.sleep(2000);
            if (checkHas(PathEnter, AiManage.getInstance().getCheckPoint())) {
                moveToClick(PathEnter, AiManage.getInstance().getCheckPoint());
                continue;
            }
            if (checkHas(PathRightdoor, AiManage.getInstance().getCheckPoint())) {
                System.out.println("发现右边的门...");
                moveToClick(PathGoLeft, AiManage.getInstance().getCheckPoint(), new Point(0, -50));
                System.out.println("往左边走一步");
                ThreadUtil.sleep(6000);
            } else {
                moveToClick(PathGoRight, AiManage.getInstance().getCheckPoint(), new Point(0, -50));
                System.out.println("往右边走一步");
                ThreadUtil.sleep(6000);
            }
        }
    }

    @Override
    public boolean check() throws AWTException {
        if (checkHas(PathCheck, AiManage.getInstance().getCheckPoint())) {
            return true;
        }
        return false;
    }

    @Override
    public void think() {
    }

    @Override
    public boolean isDone() {
        return hasChildDone();
    }

}
